package com.sf.leetcode;

import java.util.Arrays;

public class Solution_88 {

    public void merge(int[] nums1, int m, int[] nums2, int n) {
//        for (int i = m; i < nums1.length; i++) {
//            nums1[i] = nums2[i - m];
//        }
        System.arraycopy(nums2, 0, nums1, m, n);
        Arrays.sort(nums1);
    }


    // 是一种双指针的算法思想
    // 时间复杂度 O(m+n)
    // 空间复杂度 O(m+n)
    public void merge1(int[] nums1, int m, int[] nums2, int n) {
        // 同时遍历两个数组 然后将更小的值放入新的数组中 遍历完成新数组保持有序
        // 声明两个索引 代表nums1和nums2的遍历位置
        int pa = 0;
        int pb = 0;
        int[] sorted = new int[m + n];

        // 声明一个值 来记录找到的当前最小元素
        int cur;
        while (pa < m || pb < n) {
            // 假设某一个数组先遍历完
            if (pa == m) {
                cur = nums2[pb];
                pb++;
            } else if (pb == n) {
                cur = nums1[pa];
                pa++;
            } else if (nums1[pa] <= nums2[pb]) {
                // 找到更小的值 且让当前数组位置后移
                cur = nums1[pa];
                pa++;
            } else {
                cur = nums2[pb];
                pb++;
            }
            // 放到数组中的索引是什么
            // pa = 1 pb = 0
            // pa = 1 pb = 1
            sorted[pa + pb - 1] = cur;
        }

        // 将sorted中的元素 复制给nums1
        System.arraycopy(sorted, 0, nums1, 0, m + n);
    }


    public void merge2(int[] nums1, int m, int[] nums2, int n) {
        // 声明两个索引 代表nums1和nums2的遍历位置
        int pa = m - 1, pb = n - 1;
        // 记录nums1的存储位置
        int tail = m + n - 1;
        // 记录要取出的值 剩余元素中的最大值
        int cur;
        while (pa >= 0 || pb >= 0) {
            if(pa == -1){
                cur = nums2[pb--];
            }else if(pb == -1){
                cur = nums1[pa--];
            }else if (nums1[pa] > nums2[pb]) {
                cur = nums1[pa--];
            } else {
                cur = nums2[pb--];
            }
            nums1[tail--] = cur;
        }
    }


    public static void main(String[] args) {
        int[] nums1 = {1, 2, 3, 0, 0, 0};
        int[] nums2 = {2, 5, 6};
        Solution_88 solution_88 = new Solution_88();
        solution_88.merge2(nums1, 3, nums2, 3);
        System.out.println(Arrays.toString(nums1));
    }
}